Index: /LMDZ5/branches/testing/libf/phy_common/physics_distribution_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phy_common/physics_distribution_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phy_common/physics_distribution_mod.F90	(revision 2408)
@@ -0,0 +1,71 @@
+!
+!$Id$
+!
+MODULE physics_distribution_mod
+
+
+CONTAINS
+
+  SUBROUTINE init_physics_distribution(grid_type, nvertex, &
+                                       nbp, nbp_lon, nbp_lat, nbp_lev, &
+                                       communicator)
+  USE mod_phys_lmdz_para, ONLY: init_phys_lmdz_para
+  USE mod_grid_phy_lmdz, ONLY: init_grid_phy_lmdz
+  IMPLICIT NONE
+    INTEGER,INTENT(IN) :: grid_type 
+    INTEGER,INTENT(IN) :: nvertex 
+    INTEGER,INTENT(IN) :: nbp           
+    INTEGER,INTENT(IN) :: nbp_lon
+    INTEGER,INTENT(IN) :: nbp_lat
+    INTEGER,INTENT(IN) :: nbp_lev
+    INTEGER,INTENT(IN) :: communicator
+
+
+    CALL init_grid_phy_lmdz(grid_type,nvertex, nbp_lon,nbp_lat,nbp_lev)
+    CALL init_phys_lmdz_para(nbp,nbp_lon, nbp_lat, communicator)
+
+  END SUBROUTINE init_physics_distribution  
+
+!SUBROUTINE Init_Phys_lmdz(iim,jjp1,llm,nb_proc,distrib)
+!  USE mod_phys_lmdz_para, ONLY: Init_phys_lmdz_para!, klon_omp
+!  USE mod_grid_phy_lmdz, ONLY: Init_grid_phy_lmdz!, nbp_lev
+!  USE dimphy, ONLY : Init_dimphy
+!  USE infotrac_phy, ONLY : type_trac
+!#ifdef REPROBUS
+!  USE CHEM_REP, ONLY : Init_chem_rep_phys
+!#endif
+
+!  IMPLICIT NONE
+  
+!    INTEGER,INTENT(in) :: iim
+!    INTEGER,INTENT(in) :: jjp1
+!    INTEGER,INTENT(in) :: llm
+!    INTEGER,INTENT(in) :: nb_proc
+!    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+
+
+!    CALL Init_grid_phy_lmdz(iim,jjp1,llm)
+!    CALL Init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+!!$OMP PARALLEL
+!    CALL Init_dimphy(klon_omp,nbp_lev)
+!
+!! Initialization of Reprobus
+!    IF (type_trac == 'repr') THEN
+!#ifdef REPROBUS
+!       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+!#endif
+!    END IF
+!
+!!$OMP END PARALLEL
+ 
+!END SUBROUTINE Init_Phys_lmdz  
+
+
+
+
+
+
+
+
+END MODULE physics_distribution_mod
+
Index: /LMDZ5/branches/testing/libf/phy_common/print_control_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phy_common/print_control_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phy_common/print_control_mod.F90	(revision 2408)
@@ -0,0 +1,63 @@
+! $Id: $
+MODULE print_control_mod
+
+  INTEGER,SAVE :: lunout ! default output file identifier (6==screen)
+  INTEGER,SAVE :: prt_level ! debug output level
+  LOGICAL,SAVE :: debug ! flag to specify if in "debug mode"
+!$OMP THREADPRIVATE(lunout,prt_level,debug)
+
+CONTAINS
+
+  SUBROUTINE init_print_control
+  USE ioipsl_getin_p_mod, ONLY : getin_p
+  USE mod_phys_lmdz_para, ONLY: is_omp_root, is_master
+  IMPLICIT NONE
+
+    LOGICAL :: opened
+    INTEGER :: number
+    
+    !Config  Key  = prt_level
+    !Config  Desc = niveau d'impressions de débogage
+    !Config  Def  = 0
+    !Config  Help = Niveau d'impression pour le débogage
+    !Config         (0 = minimum d'impression)
+    prt_level = 0
+    CALL getin_p('prt_level',prt_level)
+
+    !Config  Key  = lunout
+    !Config  Desc = unite de fichier pour les impressions
+    !Config  Def  = 6
+    !Config  Help = unite de fichier pour les impressions 
+    !Config         (defaut sortie standard = 6)
+    lunout=6
+    CALL getin_p('lunout', lunout)
+
+    IF (is_omp_root) THEN
+      IF (lunout /= 5 .and. lunout /= 6) THEN
+         INQUIRE(FILE='lmdz.out_0000',OPENED=opened,NUMBER=number)
+         IF (opened) THEN
+           lunout=number
+         ELSE
+           OPEN(UNIT=lunout,FILE='lmdz.out_0000',ACTION='write',  &
+                STATUS='unknown',FORM='formatted')
+         ENDIF
+      ENDIF
+    ENDIF
+
+    !Config  Key  = debug
+    !Config  Desc = mode debogage
+    !Config  Def  = false
+    !Config  Help = positionne le mode debogage
+
+    debug = .FALSE.
+    CALL getin_p('debug',debug)
+    
+    IF (is_master) THEN
+      WRITE(lunout,*)"init_print_control: prt_level=",prt_level
+      WRITE(lunout,*)"init_print_control: lunout=",lunout
+      WRITE(lunout,*)"init_print_control: debug=",debug      
+    ENDIF
+    
+  END SUBROUTINE init_print_control  
+
+END MODULE print_control_mod
Index: /LMDZ5/branches/testing/libf/phy_common/regular_lonlat_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phy_common/regular_lonlat_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phy_common/regular_lonlat_mod.F90	(revision 2408)
@@ -0,0 +1,55 @@
+MODULE regular_lonlat_mod
+
+  ! Store information on the global physics grid
+  ! for a regular (longitude-latitude) grid
+  
+  INTEGER, PARAMETER :: north_east=1     ! boundaries of regular lontlat
+  INTEGER, PARAMETER :: north_west=2     ! boundaries of regular lontlat
+  INTEGER, PARAMETER :: south_west=3     ! boundaries of regular lontlat
+  INTEGER, PARAMETER :: south_east=4     ! boundaries of regular lontlat
+  INTEGER, PARAMETER :: east=1           ! boundaries of regular lontlat
+  INTEGER, PARAMETER :: west=2           ! boundaries of regular lontlat
+  INTEGER, PARAMETER :: north=1          ! boundaries of regular lontlat
+  INTEGER, PARAMETER :: south=2          ! boundaries of regular lontlat
+
+! Global definition, shared by all threads
+! Do not set threadprivate directives
+
+  REAL,SAVE,ALLOCATABLE :: lon_reg(:)      ! value of longitude cell (rad)
+
+  REAL,SAVE,ALLOCATABLE :: lat_reg(:)      ! value of longitude cell (rad)
+
+  REAL,SAVE,ALLOCATABLE :: boundslon_reg(:,:)      ! value of boundaries cell (1=>east, 2=>west)(rad)
+
+  REAL,SAVE,ALLOCATABLE :: boundslat_reg(:,:)      ! value of longitude cell (1=>north, 2=>south)(rad)
+
+
+CONTAINS
+  
+  SUBROUTINE init_regular_lonlat(nbp_lon, nbp_lat, lon_reg_, lat_reg_, boundslon_reg_, boundslat_reg_)
+    IMPLICIT NONE
+    INTEGER,INTENT(IN) :: nbp_lon
+    INTEGER,INTENT(IN) :: nbp_lat
+    REAL,   INTENT(IN) :: lon_reg_(nbp_lon)  
+    REAL,   INTENT(IN) :: lat_reg_(nbp_lat) 
+    REAL,   INTENT(IN) :: boundslon_reg_(nbp_lon,2) 
+    REAL,   INTENT(IN) :: boundslat_reg_(nbp_lat,2)  
+
+    
+    ALLOCATE(lon_reg(nbp_lon))
+    lon_reg(:)=lon_reg_(:)
+
+    ALLOCATE(lat_reg(nbp_lat)) 
+    lat_reg(:)=lat_reg_(:)
+
+    ALLOCATE(boundslon_reg(nbp_lon,2)) 
+    boundslon_reg(:,:)=boundslon_reg_(:,:)
+
+    ALLOCATE(boundslat_reg(nbp_lat,2))  
+    boundslat_reg(:,:)=boundslat_reg_(:,:)
+
+  
+  END SUBROUTINE init_regular_lonlat    
+
+END MODULE regular_lonlat_mod
+
Index: /LMDZ5/branches/testing/libf/phy_common/write_field_phy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phy_common/write_field_phy.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phy_common/write_field_phy.F90	(revision 2408)
@@ -0,0 +1,37 @@
+!
+! $Id$
+!
+MODULE write_field_phy
+
+  ! Dump a field on the global (nbp_lon by nbp_lat) physics grid
+  
+  CONTAINS 
+ 
+    SUBROUTINE WriteField_phy(name,Field,ll)
+    USE mod_phys_lmdz_para, ONLY: klon_omp, is_mpi_root, &
+                                  Gather
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
+                                 Grid1Dto2D_glo
+    USE Write_Field, ONLY: WriteField
+    
+    IMPLICIT NONE
+
+    CHARACTER(len=*),INTENT(IN) :: name
+    INTEGER,INTENT(IN) :: ll
+    REAL,INTENT(IN) :: Field(klon_omp,ll)
+
+    real, dimension(klon_glo,ll):: New_Field
+    real, dimension(nbp_lon,nbp_lat,ll):: Field_2d
+
+    CALL Gather(Field,New_Field)
+!$OMP MASTER
+    IF (is_mpi_root) THEN	
+      CALL Grid1Dto2D_glo(New_Field,Field_2D)
+      CALL WriteField(name,Field_2d)
+    ENDIF
+!$OMP END MASTER
+
+  
+   END SUBROUTINE WriteField_phy
+ 
+ END MODULE write_field_phy
Index: /LMDZ5/branches/testing/libf/phydev/infotrac_phy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/infotrac_phy.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phydev/infotrac_phy.F90	(revision 2408)
@@ -0,0 +1,27 @@
+
+! $Id: $
+
+MODULE infotrac_phy
+
+! Information on tracers for physics;
+! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
+  INTEGER, SAVE :: nqtot
+!$OMP THREADPRIVATE(nqtot)
+
+  CHARACTER(len=4),SAVE :: type_trac
+!$OMP THREADPRIVATE(type_trac)
+
+CONTAINS
+
+  SUBROUTINE init_infotrac_phy(nqtot_,type_trac_)
+  ! transfer information on tracers from dynamics to physics
+  IMPLICIT NONE
+    INTEGER,INTENT(IN) :: nqtot_
+    CHARACTER(len=4),INTENT(IN) :: type_trac_
+
+    nqtot=nqtot_
+    type_trac=type_trac_
+  
+  END SUBROUTINE init_infotrac_phy
+
+END MODULE infotrac_phy
Index: /LMDZ5/branches/testing/libf/phydev/inifis_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/inifis_mod.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phydev/inifis_mod.F90	(revision 2408)
@@ -0,0 +1,28 @@
+! $Id: $
+MODULE inifis_mod
+
+CONTAINS
+
+  SUBROUTINE inifis(prad, pg, pr, pcpp)
+  ! Initialize some physical constants and settings
+  USE print_control_mod, ONLY: init_print_control
+  USE comcstphy, ONLY: rradius, & ! planet radius (m)
+                       rr, & ! recuced gas constant: R/molar mass of atm
+                       rg, & ! gravity
+                       rcpp  ! specific heat of the atmosphere
+  IMPLICIT NONE
+
+  REAL,INTENT(IN) :: prad, pg, pr, pcpp
+
+  ! Initialize flags lunout, prt_level, debug
+  CALL init_print_control
+
+  ! copy some fundamental parameters to physics
+  rradius=prad
+  rg=pg
+  rr=pr
+  rcpp=pcpp
+
+  END SUBROUTINE inifis
+  
+END MODULE inifis_mod
Index: /LMDZ5/branches/testing/libf/phydev/iophy.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/iophy.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phydev/iophy.F90	(revision 2408)
@@ -46,4 +46,6 @@
                                 is_sequential, is_south_pole
   USE mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, klon_glo
+  USE print_control_mod, ONLY: lunout, prt_level
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat
 #ifdef CPP_IOIPSL
   USE ioipsl, only: flio_dom_set
@@ -53,6 +55,4 @@
 #endif
   implicit none
-  include 'dimensions.h'
-  include 'iniprint.h'
     real,dimension(klon),intent(in) :: rlon
     real,dimension(klon),intent(in) :: rlat
@@ -77,15 +77,19 @@
     
 !$OMP MASTER  
-    ALLOCATE(io_lat(jjm+1-1/(iim*jjm)))
+    ALLOCATE(io_lat(nbp_lat))
     io_lat(1)=rlat_glo(1)
-    io_lat(jjm+1-1/(iim*jjm))=rlat_glo(klon_glo)
-    IF ((iim*jjm) > 1) then
-      DO i=2,jjm
-        io_lat(i)=rlat_glo(2+(i-2)*iim)
+    io_lat(nbp_lat)=rlat_glo(klon_glo)
+    IF ((nbp_lon*nbp_lat) > 1) then
+      DO i=2,nbp_lat-1
+        io_lat(i)=rlat_glo(2+(i-2)*nbp_lon)
       ENDDO
     ENDIF
 
-    ALLOCATE(io_lon(iim))
-    io_lon(:)=rlon_glo(2-1/(iim*jjm):iim+1-1/(iim*jjm))
+    ALLOCATE(io_lon(nbp_lon))
+    IF ((nbp_lon*nbp_lat) > 1) THEN
+      io_lon(:)=rlon_glo(2:nbp_lon+1)
+    ELSE
+      io_lon(1)=rlon_glo(1)
+    ENDIF
 !! (I) dtnb   : total number of domains
 !! (I) dnb    : domain number
@@ -103,13 +107,13 @@
 !!              These names are case insensitive.
     ddid=(/ 1,2 /)
-    dsg=(/ iim, jjm+1-1/(iim*jjm) /)
-    dsl=(/ iim, jj_nb /)
+    dsg=(/ nbp_lon, nbp_lat /)
+    dsl=(/ nbp_lon, jj_nb /)
     dpf=(/ 1,jj_begin /)
-    dpl=(/ iim, jj_end /)
+    dpl=(/ nbp_lon, jj_end /)
     dhs=(/ ii_begin-1,0 /)
     if (mpi_rank==mpi_size-1) then
       dhe=(/0,0/)
     else
-      dhe=(/ iim-ii_end,0 /)  
+      dhe=(/ nbp_lon-ii_end,0 /)  
     endif
     
@@ -155,6 +159,7 @@
   USE mod_phys_lmdz_para, only: is_sequential, jj_begin, jj_end, jj_nb
   use ioipsl, only: histbeg
+  USE print_control_mod, ONLY: prt_level, lunout
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon
   implicit none
-  include 'dimensions.h'
     
     character*(*), intent(IN) :: name
@@ -167,9 +172,9 @@
 !$OMP MASTER    
     if (is_sequential) then
-      call histbeg(name,iim,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
-                   1,iim,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day)
+      call histbeg(name,nbp_lon,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
+                   1,nbp_lon,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day)
     else
-      call histbeg(name,iim,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
-                   1,iim,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day,phys_domain_id)
+      call histbeg(name,nbp_lon,io_lon, jj_nb,io_lat(jj_begin:jj_end), &
+                   1,nbp_lon,1,jj_nb,itau0, zjulian, dtime, nhori, nid_day,phys_domain_id)
     endif
 !$OMP END MASTER
@@ -186,5 +191,4 @@
   use wxios, only: wxios_add_file
   IMPLICIT NONE
-  include 'dimensions.h'
     
     character*(*), INTENT(IN) :: name
@@ -219,6 +223,6 @@
                                 jj_nb, klon_mpi
   USE ioipsl, only: histwrite
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon
   implicit none
-  include 'dimensions.h'
     
     integer,intent(in) :: nid
@@ -229,10 +233,10 @@
     REAL,dimension(klon_mpi) :: buffer_omp
     INTEGER, allocatable, dimension(:) :: index2d
-    REAL :: Field2d(iim,jj_nb)
+    REAL :: Field2d(nbp_lon,jj_nb)
 
     integer :: ip
     real,allocatable,dimension(:) :: fieldok
 
-    IF (size(field)/=klon) CALL abort_gcm('iophy::histwrite2d','Field first dimension not equal to klon',1)
+    IF (size(field)/=klon) CALL abort_physic('iophy::histwrite2d','Field first dimension not equal to klon',1)
     
     CALL Gather_omp(field,buffer_omp)    
@@ -240,7 +244,7 @@
     CALL grid1Dto2D_mpi(buffer_omp,Field2d)
     if(.NOT.lpoint) THEN
-     ALLOCATE(index2d(iim*jj_nb))
-     ALLOCATE(fieldok(iim*jj_nb))
-     CALL histwrite(nid,name,itau,Field2d,iim*jj_nb,index2d)
+     ALLOCATE(index2d(nbp_lon*jj_nb))
+     ALLOCATE(fieldok(nbp_lon*jj_nb))
+     CALL histwrite(nid,name,itau,Field2d,nbp_lon*jj_nb,index2d)
     else
      ALLOCATE(fieldok(npstn))
@@ -278,6 +282,6 @@
                                 jj_nb, klon_mpi
   USE ioipsl, only: histwrite
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon
   implicit none
-  include 'dimensions.h'
     
     integer,intent(in) :: nid
@@ -287,10 +291,10 @@
     real,dimension(:,:),intent(in) :: field  ! --> field(klon,:)
     REAL,dimension(klon_mpi,size(field,2)) :: buffer_omp
-    REAL :: Field3d(iim,jj_nb,size(field,2))
+    REAL :: Field3d(nbp_lon,jj_nb,size(field,2))
     INTEGER :: ip, n, nlev
     INTEGER, ALLOCATABLE, dimension(:) :: index3d
     real,allocatable, dimension(:,:) :: fieldok
 
-    IF (size(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first dimension not equal to klon',1)
+    IF (size(field,1)/=klon) CALL abort_physic('iophy::histwrite3d','Field first dimension not equal to klon',1)
     nlev=size(field,2)
 
@@ -299,7 +303,7 @@
     CALL grid1Dto2D_mpi(buffer_omp,field3d)
     if(.NOT.lpoint) THEN
-     ALLOCATE(index3d(iim*jj_nb*nlev))
-     ALLOCATE(fieldok(iim*jj_nb,nlev))
-     CALL histwrite(nid,name,itau,Field3d,iim*jj_nb*nlev,index3d)
+     ALLOCATE(index3d(nbp_lon*jj_nb*nlev))
+     ALLOCATE(fieldok(nbp_lon*jj_nb,nlev))
+     CALL histwrite(nid,name,itau,Field3d,nbp_lon*jj_nb*nlev,index3d)
     else
       nlev=size(field,2)
@@ -341,9 +345,7 @@
                                 jj_nb, klon_mpi
   USE xios, only: xios_send_field
-
-
+  USE print_control_mod, ONLY: prt_level, lunout
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon
   IMPLICIT NONE
-  INCLUDE 'dimensions.h'
-  INCLUDE 'iniprint.h'
 
     CHARACTER(LEN=*), INTENT(IN) :: field_name
@@ -351,9 +353,9 @@
       
     REAL,DIMENSION(klon_mpi) :: buffer_omp
-    REAL :: Field2d(iim,jj_nb)
+    REAL :: Field2d(nbp_lon,jj_nb)
 
     IF (prt_level >= 10) WRITE(lunout,*)'Begin histrwrite2d_xios ',trim(field_name)
 
-    IF (SIZE(field)/=klon) CALL abort_gcm('iophy::histwrite2d_xios','Field first DIMENSION not equal to klon',1)
+    IF (SIZE(field)/=klon) CALL abort_physic('iophy::histwrite2d_xios','Field first DIMENSION not equal to klon',1)
     
     CALL Gather_omp(field,buffer_omp)    
@@ -377,9 +379,8 @@
                                 jj_nb, klon_mpi
   USE xios, only: xios_send_field
-
+  USE print_control_mod, ONLY: prt_level,lunout
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon
 
   IMPLICIT NONE
-  INCLUDE 'dimensions.h'
-  INCLUDE 'iniprint.h'
 
     CHARACTER(LEN=*), INTENT(IN) :: field_name
@@ -387,5 +388,5 @@
 
     REAL,DIMENSION(klon_mpi,SIZE(field,2)) :: buffer_omp
-    REAL :: Field3d(iim,jj_nb,SIZE(field,2))
+    REAL :: Field3d(nbp_lon,jj_nb,SIZE(field,2))
     INTEGER :: ip, n, nlev
 
@@ -393,5 +394,5 @@
 
     !Et on.... écrit
-    IF (SIZE(field,1)/=klon) CALL abort_gcm('iophy::histwrite3d','Field first DIMENSION not equal to klon',1)
+    IF (SIZE(field,1)/=klon) CALL abort_physic('iophy::histwrite3d','Field first DIMENSION not equal to klon',1)
     nlev=SIZE(field,2)
 
Index: /LMDZ5/branches/testing/libf/phydev/phyaqua_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/phyaqua_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phydev/phyaqua_mod.F90	(revision 2408)
@@ -8,5 +8,5 @@
 CONTAINS
 
-  SUBROUTINE iniaqua(nlon, latfi, lonfi, iflag_phys)
+  SUBROUTINE iniaqua(nlon, iflag_phys)
 
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -15,22 +15,11 @@
   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-  USE phys_state_var_mod, ONLY: rlat, rlon, phys_state_var_init
+  USE phys_state_var_mod, ONLY: phys_state_var_init
   USE mod_phys_lmdz_para, ONLY: klon_omp
-  USE comgeomphy, ONLY: rlond, rlatd
   IMPLICIT NONE
       
   INTEGER,INTENT(IN) :: nlon,iflag_phys
-  REAL,INTENT(IN) :: lonfi(nlon),latfi(nlon)
-
-  ! local variables
-  REAL :: pi
-
-  ! initializations:
-  pi=2.*ASIN(1.)
 
   CALL phys_state_var_init()
-
-  rlat(1:klon_omp)=rlatd(1:klon_omp)*180./pi
-  rlon(1:klon_omp)=rlond(1:klon_omp)*180./pi
 
 
Index: /LMDZ5/branches/testing/libf/phydev/phyetat0.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/phyetat0.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phydev/phyetat0.F90	(revision 2408)
@@ -2,32 +2,64 @@
 ! $Id $
 !
-subroutine phyetat0(fichnom)
+SUBROUTINE phyetat0(fichnom)
 ! Load initial state for the physics
 ! and do some resulting initializations
 
-use iostart, only : open_startphy,get_field,close_startphy
-use iophy, only : init_iophy_new
-use phys_state_var_mod, only : rlat,rlon
+  USE dimphy, only: klon
+  USE iostart, ONLY : open_startphy,get_field,close_startphy
+  USE iophy, ONLY : init_iophy_new
+  USE geometry_mod, ONLY : longitude_deg, latitude_deg
 
-implicit none
+  IMPLICIT NONE
 
-character(len=*),intent(in) :: fichnom ! input file name
+  CHARACTER(len=*),INTENT(in) :: fichnom ! input file name
 
-! open physics initial state file:
-call open_startphy(fichnom)
+  REAL :: lon_startphy(klon), lat_startphy(klon)
+  INTEGER :: i
 
-! read latitudes
-call get_field("latitude",rlat)
+  ! open physics initial state file:
+  CALL open_startphy(fichnom)
 
-! read longitudes
-call get_field("longitude",rlon)
+  ! read latitudes and make a sanity check (because already known from dyn)
+  CALL get_field("latitude",lat_startphy)
+  DO i=1,klon
+    IF (ABS(lat_startphy(i)-latitude_deg(i))>=1) THEN
+      WRITE(*,*) "phyetat0: Error! Latitude discrepancy wrt startphy file:",&
+                 " i=",i," lat_startphy(i)=",lat_startphy(i),&
+                 " latitude_deg(i)=",latitude_deg(i)
+      ! This is presumably serious enough to abort run
+      CALL abort_physic("phyetat0","discrepancy in latitudes!",1)
+    ENDIF
+    IF (ABS(lat_startphy(i)-latitude_deg(i))>=0.0001) THEN
+      WRITE(*,*) "phyetat0: Warning! Latitude discrepancy wrt startphy file:",&
+                 " i=",i," lat_startphy(i)=",lat_startphy(i),&
+                 " latitude_deg(i)=",latitude_deg(i)
+    ENDIF
+  ENDDO
 
-! read in other variables here ...
+  ! read longitudes and make a sanity check (because already known from dyn)
+  CALL get_field("longitude",lon_startphy)
+  DO i=1,klon
+    IF (ABS(lon_startphy(i)-longitude_deg(i))>=1) THEN
+      WRITE(*,*) "phyetat0: Error! Longitude discrepancy wrt startphy file:",&
+                 " i=",i," lon_startphy(i)=",lon_startphy(i),&
+                 " longitude_deg(i)=",longitude_deg(i)
+      ! This is presumably serious enough to abort run
+      CALL abort_physic("phyetat0","discrepancy in longitudes!",1)
+    ENDIF
+    IF (ABS(lon_startphy(i)-longitude_deg(i))>=0.0001) THEN
+      WRITE(*,*) "phyetat0: Warning! Longitude discrepancy wrt startphy file:",&
+                 " i=",i," lon_startphy(i)=",lon_startphy(i),&
+                 " longitude_deg(i)=",longitude_deg(i)
+    ENDIF
+  ENDDO
 
-! close file
-call close_startphy
+  ! read in other variables here ...
 
-! do some more initializations
-call init_iophy_new(rlat,rlon)
+  ! close file
+  CALL close_startphy
 
-end subroutine phyetat0
+  ! do some more initializations
+  CALL init_iophy_new(latitude_deg,longitude_deg)
+
+END SUBROUTINE phyetat0
Index: /LMDZ5/branches/testing/libf/phydev/phyredem.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/phyredem.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phydev/phyredem.F90	(revision 2408)
@@ -4,6 +4,6 @@
 SUBROUTINE phyredem (fichnom)
 
+  USE geometry_mod, ONLY : longitude_deg, latitude_deg
   USE iostart, ONLY: open_restartphy, close_restartphy, put_var, put_field
-  USE phys_state_var_mod, ONLY: rlon, rlat
 
   IMPLICIT NONE
@@ -27,7 +27,7 @@
   ! coordinates
 
-  CALL put_field("longitude", "Longitudes on physics grid", rlon)
+  CALL put_field("longitude", "Longitudes on physics grid", longitude_deg)
      
-  CALL put_field("latitude", "Latitudes on physics grid", rlat)
+  CALL put_field("latitude", "Latitudes on physics grid", latitude_deg)
 
   ! close file
Index: /LMDZ5/branches/testing/libf/phydev/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/phys_state_var_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phydev/phys_state_var_mod.F90	(revision 2408)
@@ -7,9 +7,9 @@
 !======================================================================
 
-USE dimphy, only : klon
+!USE dimphy, only : klon
  
 
-REAL, ALLOCATABLE, SAVE :: rlat(:), rlon(:)
-!$OMP THREADPRIVATE(rlat,rlon)
+!REAL, ALLOCATABLE, SAVE :: rlat(:), rlon(:)
+!!$OMP THREADPRIVATE(rlat,rlon)
 
 CONTAINS
@@ -17,11 +17,11 @@
 !======================================================================
   SUBROUTINE phys_state_var_init()
-  use dimphy, only : klon
+!  use dimphy, only : klon
 
-  if (.not.allocated(rlat)) then
-    ALLOCATE(rlat(klon),rlon(klon))
-  else
-    write(*,*) "phys_state_var_init: warning, rlat already allocated"
-  endif
+!  if (.not.allocated(rlat)) then
+!    ALLOCATE(rlat(klon),rlon(klon))
+!  else
+!    write(*,*) "phys_state_var_init: warning, rlat already allocated"
+!  endif
   
   END SUBROUTINE phys_state_var_init
@@ -29,7 +29,7 @@
 !======================================================================
   SUBROUTINE phys_state_var_end
-  use dimphy, only : klon
+!  use dimphy, only : klon
 
-  deallocate(rlat,rlon)
+!  deallocate(rlat,rlon)
 
   END SUBROUTINE phys_state_var_end
Index: /LMDZ5/branches/testing/libf/phydev/physiq.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 2408)
@@ -5,5 +5,5 @@
      &            debut,lafin,jD_cur, jH_cur,pdtphys, &
      &            paprs,pplay,pphi,pphis,presnivs, &
-     &            u,v,t,qx, &
+     &            u,v,rot,t,qx, &
      &            flxmass_w, &
      &            d_u, d_v, d_t, d_qx, d_ps &
@@ -11,6 +11,6 @@
 
       USE dimphy, only : klon,klev
-      USE infotrac, only : nqtot
-      USE comgeomphy, only : rlatd
+      USE infotrac_phy, only : nqtot
+      USE geometry_mod, only : latitude
       USE comcstphy, only : rg
       USE iophy, only : histbeg_phy,histwrite_phy
@@ -18,4 +18,5 @@
       USE mod_phys_lmdz_para, only : jj_nb
       USE phys_state_var_mod, only : phys_state_var_init
+      USE mod_grid_phy_lmdz, ONLY: nbp_lon,nbp_lat
 
 #ifdef CPP_XIOS
@@ -26,8 +27,4 @@
 
       IMPLICIT none
-#include "dimensions.h"
-
-      integer,parameter :: jjmp1=jjm+1-1/jjm
-      integer,parameter :: iip1=iim+1
 !
 ! Routine argument:
@@ -55,5 +52,7 @@
       real,intent(out) :: d_qx(klon,klev,nqtot) ! physics tendency on tracers
       real,intent(out) :: d_ps(klon) ! physics tendency on surface pressure
-      real,intent(in) :: dudyn(iim+1,jjmp1,klev) ! Not used
+      real,intent(in) :: dudyn(nbp_lon+1,nbp_lat,klev) ! Not used
+      REAL, intent(in):: rot(klon, klev) ! Not used
+      ! relative vorticity, in s-1, needed for frontal waves 
 
 integer,save :: itau=0 ! counter to count number of calls to physics
@@ -114,14 +113,14 @@
   ! define variables which will be written in "histins.nc" file
   call histdef(nid_hist,'temperature','Atmospheric temperature','K', &
-               iim,jj_nb,nhori,klev,1,klev,zvertid,32, &
+               nbp_lon,jj_nb,nhori,klev,1,klev,zvertid,32, &
                'inst(X)',t_ops,t_wrt)
   call histdef(nid_hist,'u','Eastward Zonal Wind','m/s', &
-               iim,jj_nb,nhori,klev,1,klev,zvertid,32, &
+               nbp_lon,jj_nb,nhori,klev,1,klev,zvertid,32, &
                'inst(X)',t_ops,t_wrt)
   call histdef(nid_hist,'v','Northward Meridional Wind','m/s', &
-               iim,jj_nb,nhori,klev,1,klev,zvertid,32, &
+               nbp_lon,jj_nb,nhori,klev,1,klev,zvertid,32, &
                'inst(X)',t_ops,t_wrt)
   call histdef(nid_hist,'ps','Surface Pressure','Pa', &
-               iim,jj_nb,nhori,1,1,1,zvertid,32, &
+               nbp_lon,jj_nb,nhori,1,1,1,zvertid,32, &
                'inst(X)',t_ops,t_wrt)
   ! end definition sequence
@@ -160,5 +159,5 @@
 ! newtonian relaxation towards temp_newton()
 do k=1,klev
-  temp_newton(1:klon,k)=280.+cos(rlatd(1:klon))*40.-pphi(1:klon,k)/rg*6.e-3
+  temp_newton(1:klon,k)=280.+cos(latitude(1:klon))*40.-pphi(1:klon,k)/rg*6.e-3
   d_t(1:klon,k)=(temp_newton(1:klon,k)-t(1:klon,k))/1.e5
 enddo
Index: /LMDZ5/branches/testing/libf/phylmd/YOEGWD.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/YOEGWD.h	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/YOEGWD.h	(revision 2408)
@@ -20,8 +20,12 @@
 !     S_c in equation (12) of Lott (JGR, vol 118, page 8897, 2013)
 
+      REAL GWD_FRONT_RUWMAX,GWD_FRONT_SAT 
+! Same as GWD_RANDO params but for fronal GWs
+
 
       COMMON/YOEGWD/ GFRCRIT,GKWAKE,GRCRIT,GVCRIT,GKDRAG,GKLIFT,        &
      &     GHMAX,GRAHILO,GSIGCR,NKTOPG,NSTRA,GSSEC,GTSEC,GVSEC,         &
-     &     GWD_RANDO_RUWMAX, gwd_rando_sat
+     &     GWD_RANDO_RUWMAX, gwd_rando_sat,                             &
+     &     GWD_FRONT_RUWMAX, gwd_front_sat
 
       save /YOEGWD/
